########################## P3-733/256 ################################################
### magic.plugin.py
###

class Magic(Task):

	id = 'MAGIC'
	tests = [
		Test(id='00', time=0.1, score=0, dat=None, chk=None),
		Test(id='01', time=0.1, score=15, dat=None, chk=None),
		Test(id='02', time=0.1, score=15, dat=None, chk=None),
		Test(id='03', time=0.1, score=2, dat=None, chk=None),
		Test(id='04', time=0.1, score=2, dat=None, chk=None),
		Test(id='05', time=0.1, score=15, dat=None, chk=None),
		Test(id='06', time=0.1, score=2, dat=None, chk=None),
		Test(id='07', time=0.1, score=15, dat=None, chk=None),
#- --	Test(id='08', time=4.0, score=15, dat=None, chk=None), 
		Test(id='09', time=4.0, score=15, dat=None, chk=None),
#- --	Test(id='10', time=4.0, score=15, dat=None, chk=None),
		Test(id='11', time=4.0, score=2, dat=None, chk=None),
		Test(id='12', time=5.0, score=17, dat=None, chk=None),
#- --	Test(id='13', time=5.0, score=16, dat=None, chk=None),
	]

	def load_dat(self, stream):
		H = long(stream.readline())
		table = {}
		for h in range(H):
			sequence = [long(st) for st in stream.readline().split()]
			for w in range(H):
				table[h,w] = sequence[w]
		return Dat(H=H, table=table)

	def load_chk(self, stream):
		N = long(stream.readline())
		return Chk(N=N)

	def write_input(self, dat):
		self.write_line(dat.H)
		for h in range(dat.H):
			sequence = []
			for w in range(dat.H):
				sequence.append(dat.table[h,w])
			self.write_line(*sequence)

	def read_output(self, dat):
		N = self.read_line(long)
		return Sol(N=N)

###
### EOF
##########################################################################

