##########################################################################
### column.plugin.py
###

class Column(Task):

    id = 'COLUMN'
    tests = [
         Test(id='01', time=0.5, score=1, dat=None, chk=None),
#         Test(id='02', time=0.5, score=1, dat=None, chk=None),
#         Test(id='03', time=0.5, score=1, dat=None, chk=None),
#         Test(id='04', time=0.5, score=3, dat=None, chk=None),
#         Test(id='05', time=0.5, score=3, dat=None, chk=None),
#         Test(id='06', time=0.5, score=3, dat=None, chk=None),
#         Test(id='07', time=0.5, score=3, dat=None, chk=None),
#         Test(id='08', time=0.5, score=3, dat=None, chk=None),
#         Test(id='09', time=0.5, score=3, dat=None, chk=None),
#         Test(id='10', time=0.5, score=3, dat=None, chk=None),
#         Test(id='11', time=0.5, score=3, dat=None, chk=None),
#         Test(id='12', time=0.5, score=3, dat=None, chk=None),
#         Test(id='13', time=0.5, score=3, dat=None, chk=None),
#         Test(id='14', time=0.5, score=3, dat=None, chk=None),
#         Test(id='15', time=0.5, score=3, dat=None, chk=None),
#         Test(id='16', time=0.5, score=3, dat=None, chk=None),
#         Test(id='17', time=5.0, score=3, dat=None, chk=None),
#         Test(id='18', time=5.0, score=5, dat=None, chk=None),
#         Test(id='19', time=5.0, score=5, dat=None, chk=None),
#         Test(id='20', time=5.0, score=5, dat=None, chk=None),
#         Test(id='21', time=5.0, score=3, dat=None, chk=None),
#         Test(id='22', time=5.0, score=3, dat=None, chk=None),
#         Test(id='23', time=10.0, score=5, dat=None, chk=None),
#         Test(id='24', time=10.0, score=5, dat=None, chk=None),
#         Test(id='25', time=1.0, score=5, dat=None, chk=None),
    ]

    def load_dat(self, stream):
        return Dat(data=map(long, stream.readline().split()))

    def load_chk(self, stream):
        return Chk(result=map(long, stream.readline().split()))

    def write_input(self, dat):
        self.write_line(*dat.data)

    def read_output(self, dat):
        line = self.read_raw_line().split()
        try:
            result = map(long, line)
        except:
            self.break_BD()
        return Sol(result=result)

###
### EOF
##########################################################################
